FilledArea (Apache FOP 2.7 API)
Date: 2022-01-12

org.apache.fop.area.inline

## Class FilledArea

- java.lang.Object
- - org.apache.fop.area.AreaTreeObject
  - - org.apache.fop.area.Area
    - - org.apache.fop.area.inline.InlineArea
      - - org.apache.fop.area.inline.InlineParent
        - - org.apache.fop.area.inline.FilledArea

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable

      public class FilledArea
      extends InlineParent

  Filled area. This inline area contains some inline areas. When the renderer gets the child areas to render the inline areas are repeated to fill the ipd of this inline parent. This extends InlineParent so that the renderer will render this as a normal inline parent.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.fop.area.inline.InlineArea

      `InlineArea.InlineAdjustingInfo`

  - ### Field Summary

    - ### Fields inherited from class org.apache.fop.area.inline.InlineParent

      `autoSize, inlines, minChildOffset`

    - ### Fields inherited from class org.apache.fop.area.inline.InlineArea

      `adjustingInfo, blockProgressionOffset`

    - ### Fields inherited from class org.apache.fop.area.Area

      `bidiLevel, bpd, CLASS_ABSOLUTE, CLASS_BEFORE_FLOAT, CLASS_FIXED, CLASS_FOOTNOTE, CLASS_MAX, CLASS_NORMAL, CLASS_SIDE_FLOAT, effectiveIPD, ipd, log, ORIENT_0, ORIENT_180, ORIENT_270, ORIENT_90, traits`

    - ### Fields inherited from class org.apache.fop.area.AreaTreeObject

      `extensionAttachments, foreignAttributes`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FilledArea()` Create a new filled area.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `applyVariationFactor(double variationFactor, int lineStretch, int lineShrink)` Recursively apply the variation factor to all descendant areas
    `int` | `getBPD()` Get the block progression dimension of the content rectangle for this area.
    `java.util.List<InlineArea>` | `getChildAreas()` Get the child areas for this filled area.
    `int` | `getUnitWidth()` Return the unit width for the areas to fill the full width.
    `void` | `setUnitWidth(int width)` Set the unit width for the areas to fill the full width.

    - ### Methods inherited from class org.apache.fop.area.inline.InlineParent

      `addChildArea, collectInlineRuns, resetChildrenLevel`

    - ### Methods inherited from class org.apache.fop.area.inline.InlineArea

      `getAdjustingInfo, getBlockProgressionOffset, getParentArea, handleIPDVariation, hasLineThrough, hasOverline, hasUnderline, increaseIPD, isAncestor, isAncestorOrSelf, isBlinking, notifyIPDVariation, setAdjustingInfo, setAdjustingInfo, setAdjustment, setBlockProgressionOffset, setParentArea`

    - ### Methods inherited from class org.apache.fop.area.Area

      `activateEffectiveIPD, addTrait, clone, getAllocBPD, getAllocIPD, getAreaClass, getBidiLevel, getBorderAndPaddingWidthAfter, getBorderAndPaddingWidthBefore, getBorderAndPaddingWidthEnd, getBorderAndPaddingWidthStart, getChangeBarList, getEffectiveAllocIPD, getEffectiveIPD, getIPD, getSpaceAfter, getSpaceBefore, getSpaceEnd, getSpaceStart, getTrait, getTraitAsBoolean, getTraitAsInteger, getTraits, hasTrait, hasTraits, resetBidiLevel, setAreaClass, setBidiLevel, setBPD, setChangeBarList, setIPD, setTraits, setWritingModeTraits, toString`

    - ### Methods inherited from class org.apache.fop.area.AreaTreeObject

      `addExtensionAttachment, getExtensionAttachments, getForeignAttributes, getForeignAttributeValue, hasExtensionAttachments, setExtensionAttachments, setForeignAttribute, setForeignAttributes`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### FilledArea

          public FilledArea()

      Create a new filled area.

  - ### Method Detail

    - #### setUnitWidth

          public void setUnitWidth(int width)

      Set the unit width for the areas to fill the full width.
      Parameters:
        `width` - the unit width

    - #### getUnitWidth

          public int getUnitWidth()

      Return the unit width for the areas to fill the full width.
      Returns:
        the unit width

    - #### getBPD

          public int getBPD()

      Get the block progression dimension of the content rectangle for this area.
      Overrides:
        `getBPD` in class `Area`
      Returns:
        the block progression dimension
      See Also:
        bpd

    - #### getChildAreas

          public java.util.List<InlineArea> getChildAreas()

      Get the child areas for this filled area. This copies the references of the inline areas so that it fills the total width of the area a whole number of times for the unit width.
      Overrides:
        `getChildAreas` in class `InlineParent`
      Returns:
        the list of child areas copied to fill the width

    - #### applyVariationFactor

          public boolean applyVariationFactor(double variationFactor,
                                              int lineStretch,
                                              int lineShrink)

      Recursively apply the variation factor to all descendant areas
      Overrides:
        `applyVariationFactor` in class `InlineParent`
      Parameters:
        `variationFactor` - the variation factor that must be applied to adjustments
        `lineStretch` - the total stretch of the line
        `lineShrink` - the total shrink of the line
      Returns:
        true if there is an UnresolvedArea descendant

Copyright 1999-2022 The Apache Software Foundation. All Rights Reserved.